program Pascal;
{$IFDEF WIN32}
{$APPTYPE CONSOLE}
{$ENDIF}

uses
  Globals in 'unit\Globals.pas',
  Scaner in 'unit\Scaner.pas',
  Parser in 'unit\Parser.pas',
  CodeGen in 'unit\CodeGen.pas',
  Linker in 'unit\Linker.pas',
  Assembl in 'unit\Assembl.pas';

begin

  NameFile:='test.txt';
  AssignFile(Source,NameFile);
  {$I-}Reset(Source);{$I+}

  TypeTab[TypeINT].Size        :=  4;
  TypeTab[TypeINT].Kind        :=  KindSIMPLE;
  TypeTab[TypeCHAR].Size       :=  4;
  TypeTab[TypeCHAR].Kind       :=  KindSIMPLE;
  TypeTab[TypeBOOL].Size       :=  4;
  TypeTab[TypeBOOL].Kind       :=  KindSIMPLE;
  TypeTab[TypeSTR].Size        :=  0;
  TypeTab[TypeSTR].Kind        :=  KindSIMPLE;
  TypePos:=4;

  TokNameList[-1]              :=  0;
  CurLevel                     :=  -1;
  IdentPos                     :=  0;

  EnterTokbol('FALSE',IdCONST,TypeBOOL);
  IdentTab[IdentPos].Value:=ord(false);

  EnterTokbol('TRUE',IdCONST,TypeBOOL);
  IdentTab[IdentPos].Value:=ord(true);

  EnterTokbol('MAXINT',IdCONST,TypeINT);
  IdentTab[IdentPos].Value:=2147483647;

  EnterTokbol('INTEGER',IdTYPE,TypeINT);
  EnterTokbol('CHAR',IdTYPE,TypeCHAR);
  EnterTokbol('BOOLEAN',IdTYPE,TypeBOOL);

  EnterTokbol('CHR',IdFUNC,TypeCHAR);
  IdentTab[IdentPos].FLevel:=-1;
  IdentTab[IdentPos].FAdr:=FunCHR;
  IdentTab[IdentPos].Inside:=false;

  EnterTokbol('ORD',IdFUNC,TypeINT);
  IdentTab[IdentPos].FLevel:=-1;
  IdentTab[IdentPos].FAdr:=FunORD;
  IdentTab[IdentPos].Inside:=false;

  EnterTokbol('WRITE',IdFUNC,0);
  IdentTab[IdentPos].FLevel:=-1;
  IdentTab[IdentPos].FAdr:=FunWRITE;

  EnterTokbol('WRITELN',IdFUNC,0);
  IdentTab[IdentPos].FLevel:=-1;
  IdentTab[IdentPos].FAdr:=FunWRITELN;

  EnterTokbol('READ',IdFUNC,0);
  IdentTab[IdentPos].FLevel:=-1;
  IdentTab[IdentPos].FAdr:=FunREAD;

  EnterTokbol('READLN',IdFUNC,0);
  IdentTab[IdentPos].FLevel:=-1;
  IdentTab[IdentPos].FAdr:=FunREADLN;

  EnterTokbol('EOF',IdFUNC,TypeBOOL);
  IdentTab[IdentPos].FLevel:=-1;
  IdentTab[IdentPos].FAdr:=FunEOF;
  IdentTab[IdentPos].Inside:=false;

  EnterTokbol('EOLN',IdFUNC,TypeBOOL);
  IdentTab[IdentPos].FLevel:=-1;
  IdentTab[IdentPos].FAdr:=FunEOFLN;
  IdentTab[IdentPos].Inside:=false;

  TokNameList[0]:=0;
  CurLevel:=0;

  LineNum:=1;
  LinePos:=0;
                                                          
  ReadChar;
  GetToken;
  IsLabeled:=true;
  CodePos:=0;
  LastOpcode:=-1;
  StackPos:=4;

  Expect(TokPROGRAM);
  Expect(TokIdent);
  Expect(TokSemi);

  GenOp(OPJmp,0);
  Block(0);
  GenOp2(OPHalt);

  Check(TokPeriod);
  AssembleAndLink;
  CloseFile(Source);

end.
