unit Linker;

{$I+}

interface

uses
  Globals;

implementation

const
  CONSTANT_Class = 7;
  CONSTANT_Fieldref = 9;
  CONSTANT_Methodref = 10;
  CONSTANT_InterfaceMethodref = 11;
  CONSTANT_String = 8;
  CONSTANT_Integer = 3;
  CONSTANT_Float = 4;
  CONSTANT_Long = 5;
  CONSTANT_Double = 6;
  CONSTANT_NameAndType = 12;
  CONSTANT_Utf8 = 1;
  CONSTANT_Unicode = 2;
  {------------------------------}
  ACC_PUBLIC = 1;
  ACC_PRIVATE = 2;
  ACC_PROTECTED = 4;
  ACC_STATIC = 8;
  ACC_FINAL = 16;
  ACC_SYNCHRONIZED = 32;
  ACC_SUPER = 32;
  ACC_VOLATILE = 64;
  ACC_TRANSIENT = 128;
  ACC_NATIVE = 256;
  ACC_INTERFACE = 512;
  ACC_ABSTRACT = 1024;
  {}

type

{$A-} //  

  tfield_info = record
    access_flags : word;
    name_index : word;
    signature_index : word;
    attributes_count : word;
    {attributes[attribute_count]}
  end;
  {}
  tmethod_info = record
    access_flags : word;
    name_index : word;
    signature_index : word;
    attributes_count : word;
    {attributes[attribute_count]}
  end;
  {----}
  tGenericAttribute_info = record
    attribute_name : word;
    attribute_length : longInt;
    {info[attribute_length] of byte}
  end;
  {}
  tSourceFile_attribute = record
    attribute_name_index : word;
    attribute_length : longInt;
    sourcefile_index : word;
  end;
  {}
  tLineNumberTable_attribute = record
    attribute_name_index : word;
    attribute_length : longInt;
    line_number_table_length : word;
  end;
  {}
  tConstantValue_attribute = record
    attribute_name_index : word;
    attribute_length : longInt;
    constantvalue_index : word;
  end;
  {}
  tLocalVariableTable_attribute = record
    attribute_name_index : word;
    attribute_length : longInt;
    local_variable_table_length : word;
    {local_variable_table[local_variable_table_length]}
  end;
  tLocal_variable_table = record
    start_pc : word;
    length : word;
    name_index : word;
    signature_index : word;
    slot : word;
  end;
  {}
  tExceptions_attribute = record
    attribute_name_index : word;
    attribute_length : longInt;
    number_of_exceptions : word;
    {exception_index_table[number_of_exceptions] of word}
  end;
  {}
  tInnerClasses_attribute = record
    attribute_name_index : word;
    attribute_length : longInt;
    number_of_classes : word;
  end;
  {}
  tSynthetic_attribute = record
    attribute_name_index : word;
    attribute_length : longInt;
  end;
  {}
  Deprecated_attribute = record
    attribute_name_index : word;
    attribute_length : longInt;
  end;
  {}
  tCode_attribute = record
    //attribute_name_index : word;
    //attribute_length : longInt;
    max_stack : word;
    max_locals : word;
    code_length : longInt;
  end;
  tException_table = record
    start_pc : word;
    end_pc : word;
    handler_pc : word;
    catch_type : word;
  end;
  {--------------------------}

tarr = array[0..$FFFF-1] of byte;

var
  cf : record {ClassFile}
    magic : longInt;
    minor_version : word;
    major_version : word;
    constant_pool_count : word;
    cp_info :^tarr;{constant_pool[constant_pool_count - 1];}
    access_flags : word;
    this_class : word;
    super_class : word;
    interfaces_count : word;
    interfaces :^tarr;{[interfaces_count];}
    fields_count : word;
    field_info :^tarr;{fields[fields_count];}
    methods_count : word;
    method_info :^tarr;{methods[methods_count];}
    attributes_count : word;
    attribute_info :^tarr;{attributes[attribute_count];}
  end;

var
  pfield_info :^tfield_info;
  pmethod_info :^tmethod_info;
  pGenericAttribute_info :^tGenericAttribute_info;
  pCode_attribute :^tCode_attribute;
  pException_table :^tException_table;
  pexception_table_length :^word;
  pattributes_count :^word;
  pLocalVariableTable_attribute :^tLocalVariableTable_attribute;
  pLocal_variable_table :^tLocal_variable_table;

end.
