unit Scaner;

interface

uses
  Globals;

  procedure ReadChar;
  procedure GetToken;
  procedure Check(S:integer);
  procedure Expect(S:integer);

implementation

{      }

procedure ReadChar;
begin
  if not EOF(Source) then begin
    read(Source,CurChar);
    LinePos:=LinePos+1;
    if CurChar=CHR(10) then begin
      LineNum:=LineNum+1;
      LinePos:=0;
    end;
  end else begin
    CurChar:=CHR(0);
  end;
end;

{   }

function ReadNumber:integer;
var
  Num :integer;
begin
  Num:=0;
  if CurChar in ['0'..'9'] then begin
    while CurChar in ['0'..'9'] do begin
      Num:=(Num*10)+(ord(CurChar)-ord('0'));
      ReadChar;
    end;
    end else if CurChar='$' then begin
    ReadChar;
    while CurChar in ['0'..'9','A'..'F','a'..'f'] do begin
      case CurChar of
        '0'..'9': Num:=(Num*16)+(ord(CurChar)-ord('0'));
        'A'..'F': Num:=(Num*16)+(ord(CurChar)-ord('A')+10);
        'a'..'f': Num:=(Num*16)+(ord(CurChar)-ord('a')+10);
      end;
      ReadChar;
    end;
  end;
  ReadNumber:=Num;
end;

{   }

procedure GetToken;
var
  S             :integer;
  StrEnd,InStr  :boolean;
  LastChar      :char;
  Directive     : String;

  procedure DirectiveSpace;
  begin
    if (Directive = '') or (Directive[Length(Directive)] <> ' ') then
      Directive := Directive + ' ';
  end;

  procedure CompilerDirective;
  begin
    Directive := TrimRight(Directive);
    if SameText(Directive, 'APPTYPE CONSOLE') then
      ConsoleApp := True
    else if SameText(Directive, 'APPTYPE GUI') then
      ConsoleApp := False
    else if SameText(Copy(Directive, 1, 2), 'I ') then
      //HandleInclude (Copy(Directive, 3, Maxint))
    else
      Error(804);
  end;

begin

  while (CurChar>CHR(0)) and (CurChar<=' ') do ReadChar;

  CurID:='';
  CurStr:='';

  case CurChar of

    'a'..'z',
    'A'..'Z':
              begin
                while CurChar in ['a'..'z','A'..'Z','0'..'9','_'] do begin
                  CurStr:=CurStr+CurChar;
                  if CurChar in ['a'..'z'] then CurChar:=chr(ord(CurChar)-32);
                  CurID:=CurID+CurChar;
                  ReadChar;
                end;
                CurTok:=TokIdent;
                S:=TokBEGIN;
                while S<=TokASM do begin
                  if Keywords[S]=CurID then CurTok:=S;
                  S:=S+1;
                end;
              end;
    '0'..'9',
    '$':      begin CurTok:=TokNumber; CurNum:=ReadNumber; end;
    ':':
              begin
                ReadChar;
                if CurChar='=' then begin
                  ReadChar;
                  CurTok:=TokAssign;
                end else
                  CurTok:=TokColon;
              end;
    '>':
              begin
                ReadChar;
                if CurChar='=' then begin
                  ReadChar;
                  CurTok:=TokGEq;
                end else
                  CurTok:=TokGtr;
              end;
    '<':
              begin
                ReadChar;
                if CurChar='=' then begin
                  ReadChar;
                  CurTok:=TokLEq;
                end else if CurChar='>' then begin
                  ReadChar;
                  CurTok:=TokNEq;
                end else
                  CurTok:=TokLss;
              end;
    '.':
              begin
                ReadChar;
                if CurChar='.' then begin
                  ReadChar;
                  CurTok:=TokColon;
                end else begin
                  CurTok:=TokPeriod
                end;
              end;
    '''','#':
              begin
                CurStrLen:=0;
                StrEnd:=false;
                InStr:=false;
                CurTok:=TokStrC;
                while not StrEnd do begin
                  if InStr then begin
                    if CurChar='''' then begin
                      ReadChar;
                      if CurChar='''' then begin
                        if CurStrLen=255 then Error(903);
                        CurStrLen:=CurStrLen+1;
                        CurStr:=CurStr+CurChar;
                        ReadChar;
                      end else begin
                        InStr:=false;
                      end;
                    end else if CurChar in [#13,#10] then begin
                      Error(100);
                      StrEnd:=true;
                    end else begin
                      if CurStrLen=255 then Error(903);
                      CurStrLen:=CurStrLen+1;
                      CurStr:=CurStr+CurChar;
                      ReadChar;
                    end;
                  end else begin
                    if CurChar='''' then begin
                      InStr:=true;
                      ReadChar;
                    end else if CurChar='#' then begin
                      ReadChar;
                      if CurStrLen=255 then Error(903);
                      CurStrLen:=CurStrLen+1;
                      CurStr:=CurStr+chr(ReadNumber);
                    end else
                      StrEnd:=true;
                  end;
                end;
                if CurStrLen=0 then Error(101);
              end;
    '(':
              begin
                ReadChar;
                if CurChar='*' then begin
                  ReadChar;
                  LastChar:='-';
                  while not ((CurChar=')') and (LastChar='*')) do begin
                    LastChar:=CurChar;
                    ReadChar;
                  end;
                  ReadChar;
                  GetToken;
                end else
                  CurTok:=TokLParent;
              end;
    '/':
              begin //  
                ReadChar;
                if CurChar='/' then begin
                  while not (CurChar=chr(10)) or (CurChar=chr(13)) do ReadChar;
                  ReadChar;
                  GetToken;
                end else
                  CurTok:=TokDVD;
              end;
    '+':      begin ReadChar; CurTok:=TokPlus;      end;
    '-':      begin ReadChar; CurTok:=TokMinus;     end;
    '*':      begin ReadChar; CurTok:=TokMul;       end;
    ')':      begin ReadChar; CurTok:=TokRParent;   end;
    '[':      begin ReadChar; CurTok:=TokLBracket;  end;
    ']':      begin ReadChar; CurTok:=TokRBracket;  end;
    '=':      begin ReadChar; CurTok:=TokEql;       end;
    ',':      begin ReadChar; CurTok:=TokComma;     end;
    ';':      begin ReadChar; CurTok:=TokSemi;      end;

    '{':
              begin
                Directive := '';
                ReadChar;
                if CurChar='$' then begin
                  while True do begin
                    ReadChar;
                    case CurChar of
                      #0:  Error (805);
                      #1..' ': DirectiveSpace;
                      '}': Break;
                    else
                      Directive := Directive + CurChar;
                    end;
                  end;
                  CompilerDirective;
                end else
                while CurChar<>'}' do ReadChar;
                ReadChar;
                GetToken;
              end;
  else
    Error(102);
  end;
end;

procedure Check(S:integer);
begin
  if CurTok<>S then begin
    Error(S);
  end;
end;

procedure Expect(S:integer);
begin
  Check(S);
  GetToken;
end;

end.
